(function (WScript) {
    var out = '';   
    var fso = WScript.CreateObject('Scripting.FileSystemObject');
    
    var xdt_missing_equs = [
        'return equ >0012',
        'pad    equ >8300',
        'link   equ >0010',
        'accton equ >0034',
        'badton equ >0036',
        'upcase equ >004a',
        'locase equ >0018',
        'fsub   equ >0007',
        'fdiv   equ >0009',
        'cfi    equ >0012',
        'cns    equ >0014'
    ];
    
    var no_operands = [ 'H', 'GT', 'CARRY', 'CARR', 'OVF', 'RTN', 'RTNC',
        'SCAN', 'EXIT', 'CONT', 'EXEC', 'RTNB', 'RTGR', 'FMT', 'FEND' ];
    
    var d = fso.GetFolder('.');
    var e = new Enumerator(d.Files);
    var l = [];
    for (; !e.atEnd(); e.moveNext())
        if (extension(e.item()) == '') l.push(e.item().Name);
    convert(group(l, 'srxb3'));
    convert(group(l, 'srxb4'));
    convert(group(l, 'srxb5'));
    convert(group(l, 'srxb6'));
    convert(group(l, 'srxb7'));
    echo('RXB source converted');
    WScript.Echo(out);
    
    function echo(s) { out += s + '\n'; }
    
    function readBinary(f, sz) {
        var s = WScript.CreateObject('ADODB.Stream');
        s.Type = 1;
        s.Open();
        s.LoadFromFile(f);
        s.Position = 0;
        var d = s.Read();
        s.Close();
        var rs = WScript.CreateObject('ADODB.Recordset');
        rs.Fields.Append('test', 201, sz, 0x80);
        rs.Open();
        rs.AddNew();
        rs.Fields('test').AppendChunk(d);
        rs.Update();
        rs.MoveFirst();
        var s2 = rs('test').GetChunk(sz);
        rs.Close();
        return s2;
    }
    
    function writeText(f, s) {
        var f2 = fso.OpenTextFile(f, 2, true);
        f2.Write(s);
        f2.Close();
    }
    
    function dv80Lines(s) {
        var s2 = '';
        var i = 128;
        var a = [];
        do {
            var n = s.charCodeAt(i);
            if (!n) break;
            if (n == 255) {
                i = (Math.floor(i / 128) + 1) * 128;
                if (i < s.length) continue;
                else break;
            }
            a.push(s.substr(i + 1, n));
            i += 1 + n;
        } while(1);
        return a;
    }
    
    function deleteCopyAndAfter(a) {
        for (var i = a.length; i--;) {
            var a2 = a[i].split(/\s+/);
            if (a2[0] == 'COPY') {
                var n = a.length - i;
                for (var i2 = n; i2--;) a.pop();
                break;
            }
        }
    }
    
    function extension(f) {
        var s = f.Name;
        return (/[.]/.exec(s)) ? /[^.]+$/.exec(s) : '';
    }
    
    function group(l, s) {
        var l2 = [];
        var r = new RegExp(s + '.*', 'i');
        for (var i in l) if (r.test(l[i])) l2.push(l[i]);
        l2.sort(function(a, b) {
            if (a < b) return -1;
            if (a > b) return 1;
            return 0;
        });
        var g = {};
        g.output = s + '.gpl';
        g.files = l2;
        return g;
    }
    
    function convert(g) {
        var txt = '';
        for (var i in xdt_missing_equs)
            txt += xdt_missing_equs[i] + '\r\n';
        for (var i in g.files) {
            var s = readBinary(g.files[i], 100000);
            var a = dv80Lines(s);
            deleteCopyAndAfter(a);
            deleteAfterEnd(a);
            for (var i2 in a) {
                s = convertSourceLine(a[i2]);
                txt += s + '\r\n';
            };
        }
        writeText(g.output, txt);
    }
    
    function deleteAfterEnd(a) {
        for (var i = a.length; i--;) {
            var a2 = a[i].split(/\s+/);
            if (a2[0] == 'END') {
                var n = a.length - i;
                for (var i2 = n; i2--;) a.pop();
                break;
            }
        }
    }
    
    function convertSourceLine(s) {
        if (s.charAt(0) == '*') return s;
        var s2 = s.replace(/^\s+|\s+$/g, '');
        if (s2.charAt(0) == '*') return s.replace(/\*/,';');
        if (s2.length == 0) return s;
        var i = 3;
        var label = true;
        if (s.charAt(0) == ' ') {
            i = 2;
            label = false;
        }
        s = s.replace(/'[^']+'/g, function(m) {
            return m.replace(/\s/g, String.fromCharCode(0xFF));
        });
        var a = s.split(/\s+/);
        if ((i - 2) < a.length) {
            if (arrayIndexOf(no_operands, a[i - 2]) != -1)
                i = i - 1;
            if (a[i - 1] == 'CARR') a[i - 1] = 'CARRY';
            var s3 = a[i - 1];
            if (a[i - 2] == 'DATA' && s3.charAt(s3.length - 1) == ',')
                a[i - 1] = s3.substr(0, s3.length - 1);
            if (a[i - 2] == 'S') a[i - 2] = 'SUB';
            if (a[0] == 'FDIV' || a[0] == 'CFI')
                a[0] = '* ' + a[0];
        }
        if (i < a.length) a[i] = '; ' + a[i];
        s2 = a.join(' ');
        s2 = s2.replace(new RegExp(String.fromCharCode(0xFF), 'g'),' ');
        if (!label) s2 = ' ' + s2;
        return s2;
    }
    
    function arrayIndexOf(a, it) {
        for (var i = 0; i < a.length; i++)
            if (a[i] === it) return i;
        return -1;
    }
})(WScript);